summaryrefslogtreecommitdiffabout
Unidiff
Diffstat (more/less context) (ignore whitespace changes)
-rwxr-xr-xtests/setup.sh2
-rwxr-xr-xtests/t0010-validate-html.sh9
2 files changed, 9 insertions, 2 deletions
diff --git a/tests/setup.sh b/tests/setup.sh
index 95acb54..30f90d5 100755
--- a/tests/setup.sh
+++ b/tests/setup.sh
@@ -1,129 +1,129 @@
1# This file should be sourced by all test-scripts 1# This file should be sourced by all test-scripts
2# 2#
3# Main functions: 3# Main functions:
4# prepare_tests(description) - setup for testing, i.e. create repos+config 4# prepare_tests(description) - setup for testing, i.e. create repos+config
5# run_test(description, script) - run one test, i.e. eval script 5# run_test(description, script) - run one test, i.e. eval script
6# 6#
7# Helper functions 7# Helper functions
8# cgit_query(querystring) - call cgit with the specified querystring 8# cgit_query(querystring) - call cgit with the specified querystring
9# cgit_url(url) - call cgit with the specified virtual url 9# cgit_url(url) - call cgit with the specified virtual url
10# 10#
11# Example script: 11# Example script:
12# 12#
13# . setup.sh 13# . setup.sh
14# prepare_tests "html validation" 14# prepare_tests "html validation"
15# run_test 'repo index' 'cgit_url "/" | tidy -e' 15# run_test 'repo index' 'cgit_url "/" | tidy -e'
16# run_test 'repo summary' 'cgit_url "/foo" | tidy -e' 16# run_test 'repo summary' 'cgit_url "/foo" | tidy -e'
17 17
18 18
19mkrepo() { 19mkrepo() {
20 name=$1 20 name=$1
21 count=$2 21 count=$2
22 dir=$PWD 22 dir=$PWD
23 test -d $name && return 23 test -d $name && return
24 printf "Creating testrepo %s\n" $name 24 printf "Creating testrepo %s\n" $name
25 mkdir -p $name 25 mkdir -p $name
26 cd $name 26 cd $name
27 git init 27 git init
28 n=1 28 n=1
29 while test $n -le $count 29 while test $n -le $count
30 do 30 do
31 echo $n >file-$n 31 echo $n >file-$n
32 git add file-$n 32 git add file-$n
33 git commit -m "commit $n" 33 git commit -m "commit $n"
34 n=$(expr $n + 1) 34 n=$(expr $n + 1)
35 done 35 done
36 if test "$3" = "testplus" 36 if test "$3" = "testplus"
37 then 37 then
38 echo "hello" >a+b 38 echo "hello" >a+b
39 git add a+b 39 git add a+b
40 git commit -m "add a+b" 40 git commit -m "add a+b"
41 git branch "1+2" 41 git branch "1+2"
42 fi 42 fi
43 cd $dir 43 cd $dir
44} 44}
45 45
46setup_repos() 46setup_repos()
47{ 47{
48 rm -rf trash/cache 48 rm -rf trash/cache
49 mkdir -p trash/cache 49 mkdir -p trash/cache
50 mkrepo trash/repos/foo 5 >/dev/null 50 mkrepo trash/repos/foo 5 >/dev/null
51 mkrepo trash/repos/bar 50 >/dev/null 51 mkrepo trash/repos/bar 50 >/dev/null
52 mkrepo trash/repos/foo+bar 10 testplus >/dev/null 52 mkrepo trash/repos/foo+bar 10 testplus >/dev/null
53 cat >trash/cgitrc <<EOF 53 cat >trash/cgitrc <<EOF
54virtual-root=/ 54virtual-root=/
55cache-root=$PWD/trash/cache 55cache-root=$PWD/trash/cache
56 56
57cache-size=1021 57cache-size=1021
58snapshots=tar.gz tar.bz zip 58snapshots=tar.gz tar.bz zip
59enable-log-filecount=1 59enable-log-filecount=1
60enable-log-linecount=1 60enable-log-linecount=1
61summary-log=5 61summary-log=5
62summary-branches=5 62summary-branches=5
63summary-tags=5 63summary-tags=5
64 64
65repo.url=foo 65repo.url=foo
66repo.path=$PWD/trash/repos/foo/.git 66repo.path=$PWD/trash/repos/foo/.git
67# Do not specify a description for this repo, as it then will be assigned 67# Do not specify a description for this repo, as it then will be assigned
68# the constant value "[no description]" (which actually used to cause a 68# the constant value "[no description]" (which actually used to cause a
69# segfault). 69# segfault).
70 70
71repo.url=bar 71repo.url=bar
72repo.path=$PWD/trash/repos/bar/.git 72repo.path=$PWD/trash/repos/bar/.git
73repo.desc=the bar repo 73repo.desc=the bar repo
74 74
75repo.url=foo+bar 75repo.url=foo+bar
76repo.path=$PWD/trash/repos/foo+bar/.git 76repo.path=$PWD/trash/repos/foo+bar/.git
77repo.desc=the foo+bar repo 77repo.desc=the foo+bar repo
78EOF 78EOF
79} 79}
80 80
81prepare_tests() 81prepare_tests()
82{ 82{
83 setup_repos 83 setup_repos
84 rm -f test-output.log 2>/dev/null 84 rm -f test-output.log 2>/dev/null
85 test_count=0 85 test_count=0
86 test_failed=0 86 test_failed=0
87 echo "[$0]" "$@" >test-output.log 87 echo "[$0]" "$@" >test-output.log
88 echo "$@" "($0)" 88 echo "$@" "($0)"
89} 89}
90 90
91tests_done() 91tests_done()
92{ 92{
93 printf "\n" 93 printf "\n"
94 if test $test_failed -gt 0 94 if test $test_failed -gt 0
95 then 95 then
96 printf "test: *** %s failure(s), logfile=%s\n" \ 96 printf "test: *** %s failure(s), logfile=%s\n" \
97 $test_failed "$(pwd)/test-output.log" 97 $test_failed "$(pwd)/test-output.log"
98 false 98 false
99 fi 99 fi
100} 100}
101 101
102run_test() 102run_test()
103{ 103{
104 desc=$1 104 desc=$1
105 script=$2 105 script=$2
106 test_count=$(expr $test_count + 1) 106 test_count=$(expr $test_count + 1)
107 printf "\ntest %d: name='%s'\n" $test_count "$desc" >>test-output.log 107 printf "\ntest %d: name='%s'\n" $test_count "$desc" >>test-output.log
108 printf "test %d: eval='%s'\n" $test_count "$2" >>test-output.log 108 printf "test %d: eval='%s'\n" $test_count "$2" >>test-output.log
109 eval "$2" >>test-output.log 2>>test-output.log 109 eval "$2" >>test-output.log 2>>test-output.log
110 res=$? 110 res=$?
111 printf "test %d: exitcode=%d\n" $test_count $res >>test-output.log 111 printf "test %d: exitcode=%d\n" $test_count $res >>test-output.log
112 if test $res = 0 112 if test $res = 0
113 then 113 then
114 printf " %2d) %-60s [ok]\n" $test_count "$desc" 114 printf " %2d) %-60s [ok]\n" $test_count "$desc"
115 else 115 else
116 ((test_failed++)) 116 test_failed=$(expr $test_failed + 1)
117 printf " %2d) %-60s [failed]\n" $test_count "$desc" 117 printf " %2d) %-60s [failed]\n" $test_count "$desc"
118 fi 118 fi
119} 119}
120 120
121cgit_query() 121cgit_query()
122{ 122{
123 CGIT_CONFIG="$PWD/trash/cgitrc" QUERY_STRING="$1" "$PWD/../cgit" 123 CGIT_CONFIG="$PWD/trash/cgitrc" QUERY_STRING="$1" "$PWD/../cgit"
124} 124}
125 125
126cgit_url() 126cgit_url()
127{ 127{
128 CGIT_CONFIG="$PWD/trash/cgitrc" QUERY_STRING="url=$1" "$PWD/../cgit" 128 CGIT_CONFIG="$PWD/trash/cgitrc" QUERY_STRING="url=$1" "$PWD/../cgit"
129} 129}
diff --git a/tests/t0010-validate-html.sh b/tests/t0010-validate-html.sh
index 94aa52b..3fe4800 100755
--- a/tests/t0010-validate-html.sh
+++ b/tests/t0010-validate-html.sh
@@ -1,34 +1,41 @@
1#!/bin/sh 1#!/bin/sh
2 2
3. ./setup.sh 3. ./setup.sh
4 4
5 5
6test_url() 6test_url()
7{ 7{
8 tidy_opt="-eq" 8 tidy_opt="-eq"
9 test -z "$NO_TIDY_WARNINGS" || tidy_opt+=" --show-warnings no" 9 test -z "$NO_TIDY_WARNINGS" || tidy_opt+=" --show-warnings no"
10 cgit_url "$1" >trash/tidy-$test_count || return 10 cgit_url "$1" >trash/tidy-$test_count || return
11 sed -ie "1,4d" trash/tidy-$test_count || return 11 sed -ie "1,4d" trash/tidy-$test_count || return
12 tidy $tidy_opt trash/tidy-$test_count 12 "$tidy" $tidy_opt trash/tidy-$test_count
13 rc=$? 13 rc=$?
14 14
15 # tidy returns with exitcode 1 on warnings, 2 on error 15 # tidy returns with exitcode 1 on warnings, 2 on error
16 if test $rc = 2 16 if test $rc = 2
17 then 17 then
18 false 18 false
19 else 19 else
20 : 20 :
21 fi 21 fi
22} 22}
23 23
24prepare_tests 'Validate html with tidy' 24prepare_tests 'Validate html with tidy'
25 25
26tidy=`which tidy`
27test -n "$tidy" || {
28 echo "Skipping tests: tidy not found"
29 tests_done
30 exit
31}
32
26run_test 'index page' 'test_url ""' 33run_test 'index page' 'test_url ""'
27run_test 'foo' 'test_url "foo"' 34run_test 'foo' 'test_url "foo"'
28run_test 'foo/log' 'test_url "foo/log"' 35run_test 'foo/log' 'test_url "foo/log"'
29run_test 'foo/tree' 'test_url "foo/tree"' 36run_test 'foo/tree' 'test_url "foo/tree"'
30run_test 'foo/tree/file-1' 'test_url "foo/tree/file-1"' 37run_test 'foo/tree/file-1' 'test_url "foo/tree/file-1"'
31run_test 'foo/commit' 'test_url "foo/commit"' 38run_test 'foo/commit' 'test_url "foo/commit"'
32run_test 'foo/diff' 'test_url "foo/diff"' 39run_test 'foo/diff' 'test_url "foo/diff"'
33 40
34tests_done 41tests_done